/***********************************************
 *    Read or Write image data  (lee yongbum)  *
 ***********************************************/

#include <stdio.h>
#include <sys/stat.h>


void read_short(short *,int,int,char *);
void write_short(short *,int,char *);
void read_ushort(unsigned short *,int,int,char *);
void write_ushort(unsigned short *,int,char *);
void read_char(char *,int,int,char *);
void write_char(char *,int,char *);
void read_uchar(unsigned char *,int,int,char *);
void write_uchar(unsigned char *,int,char *);

/*short read*/
void 
read_short(short *image,int size,
		 int header,char *filename)
{
    int i,c;
    FILE *fp;
    if ((fp=fopen(filename,"rb")) == NULL){
	printf("File Open Error (Read)!\n");
	exit(-1);
    }
    for(i=0;i<header;i++){
      c=fgetc(fp);
    }
    fread(image,sizeof(short),size,fp);
    fclose(fp);
}
/*short write*/
void 
write_short(short *image,int size,
                 char *filename)
{
    FILE *fp;

    if ((fp=fopen(filename,"wb")) == NULL){
        printf("File Open Error (Write)!\n");
        exit(-1);
      }
    fwrite(image,sizeof(short),size,fp);
    fclose(fp);
}

/*unsigned short read*/
void 
read_ushort(unsigned short *image,int size,
		    int header,char *filename)
{
    int i,c;
    FILE *fp;
    if ((fp=fopen(filename,"rb")) == NULL){
        printf("File Open Error !\n");
        exit(-1);
    }
    for(i=0;i<header;i++){
      c=fgetc(fp);
    }
    fread(image,sizeof(short),size,fp);
    fclose(fp);
}
/*unsigned short write*/
void
write_ushort(unsigned short *image,int size,
                 char *filename)
{
    FILE *fp;
    if ((fp=fopen(filename,"wb")) == NULL){
        printf("File Open Error (Write)!\n");
        exit(-1);
      }
    fwrite(image,sizeof(unsigned short),size,fp);
    fclose(fp);
}

/*char read*/
void 
read_char(char *image,int size,
		int header,char *filename)
{
    int i,c;
    FILE *fp;
    if ((fp=fopen(filename,"rb")) == NULL){
        printf("File Open Error !\n");
        exit(-1);
    }
    for(i=0;i<header;i++){
      c=fgetc(fp);
    }
    fread(image,sizeof(char),size,fp);
    fclose(fp);
}
/*char write*/
void
write_char(char *image,int size,
                 char *filename)
{
    FILE *fp;
    if ((fp=fopen(filename,"wb")) == NULL){
        printf("File Open Error (Write)!\n");
        exit(-1);
      }
    fwrite(image,sizeof(char),size,fp);
    fclose(fp);
}

/*unsigned char read*/
void 
read_uchar(unsigned char *image,int size,
		   int header,char *filename)
{
    int i,c;
    FILE *fp;

    if ((fp=fopen(filename,"rb")) == NULL){
        printf("File Open Error !\n");
        exit(-1);
    }
    for(i=0;i<header;i++){
      c=fgetc(fp);
    }
    if ((fread(image,sizeof(char),size,fp)) != size) {
      puts("fread error !!\n");
      fclose(fp);
      exit(-1);
    }
    fclose(fp);
}
/*unsigned char write*/
void
write_uchar(unsigned char *image,int size,
                 char *filename)
{
    FILE *fp;

    if ((fp=fopen(filename,"wb")) == NULL){
        printf("File Open Error (Write)!\n");
        exit(-1);
      }
    fwrite(image,sizeof(unsigned char),size,fp);
    fclose(fp);
}

int calc_zs(filename,xs,ys,byte)
char *filename;
int xs;
int ys;
int byte;
{
    struct stat stat_buf;
    FILE        *fp;
    int         filesize,zs;

    if(( fp = fopen(filename, "r" ))==NULL ){
        printf("Can't Read Orignal \n");
        exit(1);
    }
    stat( filename, &stat_buf );
    fclose( fp );

    filesize = stat_buf.st_size;
    
    zs = filesize / (xs*ys*byte);
    return(zs);
}
