#include <stdio.h>

void calc_maxmin(unsigned short *,int,int *, int *);
void winproc(unsigned short *,unsigned char *,int);
void reverse(unsigned char *, int);
void reduction(unsigned char *,int,int,int);

void winproc(unsigned short *data1,unsigned char *data2,int xysize)
{
  int i;
  float min=0.0,max=255.0;
  float result,top,bottom;
  float level,width,value;
  int vmax,vmin;

  calc_maxmin(data1,xysize,&vmax,&vmin);

  level = (float)(vmin+(vmax-vmin)/2); 
  width = (float)(vmax-vmin);
  top = (float)(level+width/2);
  bottom = (float)(level-width/2);
  if(top>vmax)       top=vmax;
  if(bottom<vmin)    bottom=vmin;

  for( i = 0; i < xysize; i++ )
  {
      value = (float)(data1[i]);
      if(value >= top){
        result = max;
      }
      else if(value <= bottom){
        result = min;
      }
      else{
        result = (value-bottom)/width*255.0;
      }
      data2[i] = (int)result;
  }
}

void calc_maxmin(unsigned short *s_image,int size,int *vmax, int *vmin)
{
    int i,max,min;
    
    max=0;
    min=1000000;
    for(i=0;i<size;i++){
        if(s_image[i]>max)max=s_image[i];
        if(s_image[i]<min)min=s_image[i];
    }
    *vmax = max;
    *vmin = min;
}

void reverse(unsigned char *c_image, int size)
{
    int i, max, min;

    max=0;
    for(i=0;i<size;i++)
        if(c_image[i]>max) max=c_image[i];

    for(i=0;i<size;i++)
      c_image[i] = max - c_image[i];
}

void reduction(unsigned char *in, int ix, int iy,int cs)
{
  int i,j,k,l,n,jj,ii,sum;
  
  n=0;
  for (j=0; j<iy; j=j+cs){
    for (i=0; i<ix; i=i+cs){
      sum = 0;
      for(l=0; l<cs; l++){
	for(k=0; k<cs; k++){
	  if(j+l>iy-1)jj=iy-1; else jj=j+l;
	  if(i+k>ix-1)ii=ix-1; else ii=i+k;
	  sum += in[jj*ix + ii];
	}
      }
      in[n]=(unsigned char)(sum/(cs*cs));
      n++;
    }
  }
}
